/***************************************************************************
// Written by J. Keller, julien.keller@univ-amu.fr (2014) //
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "m_matrix2.h"


template<class T> void show(const MMatrix<T> A,char* a)
{
    int i, j;
    cout << a <<endl;
    for(i=0;i<A.getHeight();i++)
    {
        for(j=0;j<A.getWidth();j++)
        {
            cout << A[i][j] << " ";
        }
        cout << "\n";
    }
}


/* Print the matrix to std output*/
void show(MMatrix<double> A)
{
    int i, j;
    printf("showing... \n");
    for(i=0;i<A.getHeight();i++)
    {
        for(j=0;j<A.getWidth();j++)
        {
            if (A[i][j]>=1000 || -A[i][j]>=1000)
            {
                printf("%+.2e ", A[i][j]);
            }
            else
            {
                if
                (A[i][j]>=100 || -A[i][j]>=100)
                {
                    printf("%+7.4f ", A[i][j]);
                }
                else
                {
                    if
                    (A[i][j]>=10 || -A[i][j]>=10)
                    {
                        printf("%+7.5f ", A[i][j]);
                    }
               /*          if (A[i][j]==0)
                    { printf("    0    "); } */
                    else
                    {
                        if (A[i][j]==0)
                        { printf("    0     "); }
                        else
                        {
                            printf("%+6.6f ", A[i][j]);
                        }
                    }
                }
            }

        }
        printf("\n");
    }
}
void show(MMatrix<int> A)
{
    int i, j;
    printf("showing... \n");
    for(i=0;i<A.getHeight();i++)
    {
        for(j=0;j<A.getWidth();j++)
        {

            printf(" %d ",A[i][j]);

        }
        printf("\n");
    }
}



/* Print the matrix to std output with a given string */
void show(MMatrix <double> A,char* a)
{
    int i, j;
    if((A.getHeight()!=0) && (A.getWidth()!=0))
    {
        printf("showing...%s \n",a);
        for(i=0;i<A.getHeight();i++)
        {
            for(j=0;j<A.getWidth();j++)
            {
                if (A[i][j]>=1000 || -A[i][j]>=1000)
                {
                    printf("%+.2e ", A[i][j]);
                }
                else
                {
                    if
                    (A[i][j]>=100 || -A[i][j]>=100)
                    {
                        printf("%+7.4f ", A[i][j]);
                    }
                    else
                    {
                        if
                        (A[i][j]>=10 || -A[i][j]>=10)
                        {
                            printf("%+7.5f ", A[i][j]);
                        }
                  /*             if (A[i][j]==0)
                        { printf("    0    "); } */
                        else
                        {
                            if (A[i][j]==0)
                            { printf("    0     "); }
                            else
                            {
                                printf("%+6.6f ", A[i][j]);
                            }
                        }
                    }
                }

            }
            printf("\n");
        }
    }
}



/* Extending previous procedure to Complex data */
void show(MMatrix<Complex> A)
{
    int i, j;
    printf("showing... \n");
    for(i=0;i<A.getHeight();i++)
    {
        for(j=0;j<A.getWidth();j++)
        {

         /* if (A[i][j]>=1000 || -A[i][j]>=1000)
            {
            printf("%+.2e ", A[i][j]);
        }
            else
            { if     
            (A[i][j]>=100 || -A[i][j]>=100){
            printf("%+7.4f ", A[i][j]);
        }
            else
            {  
            if     
            (A[i][j]>=10 || -A[i][j]>=10){
            printf("%+7.5f ", A[i][j]);
        }
         /*          if (A[i][j]==0)
            { printf("    0    "); } 
         */
            if (A[i][j]!=complex<double>(0,0))
            {
                printf("%.4f %+.4fI ",real(A[i][j]),imag(A[i][j]));
            }
            else
            {
                printf("       0       ");
            }
         /*    {
            if (A[i][j]==0)
            { printf("    0     "); } 
            else 
            {
            printf("%+6.6f ", A[i][j]);
        }      
        }
        }
        }        
         */
        }
        printf("\n");

    }
}

/*
MMatrix<double>& invertNonZeroElements(MMatrix<double>& M)
{
    int i,j;
    for(i=0;i<M.getHeight();i++)
    {
        for(j=0;j<M.getWidth();j++)
        {
            if (M[i][j] != 0)
            {
                M[i][j]=1./M[i][j];
            }
        }
    }
    return M;
}

*/
/* inverse elements for half of the matrix */
/*
MMatrix<double> inverse_elements(MMatrix<double> M)
{
    int i,j;
    for(i=0;i<M.getHeight();i++)
    {
        for(j=0;j<M.getWidth()-i;j++)
        {
            M[i][j]=1./M[i][j];
        }
    }
    return M;
}
*/

/* normal transpose */
/*MMatrix<double> transpose(MMatrix<double>M)
{
    return M.transpose();
}
*/
/* special ""transpose"" */
/*
MMatrix<double> transpose2(MMatrix<double> M)
{
    int i,j;
    MMatrix<double> N(M.getHeight(),M.getWidth());
    for(i=0;i<M.getHeight();i++)
    {
        for(j=0;j<M.getWidth()-i;j++)
        {
            N[i][j]=M[M.getHeight()-1-(i+j)][i]+M[j][M.getWidth()-1-(i+j)];
        }
    }
    return N;
}
*/
/* scalar product of two vectors */
/*double  scalar_product(MMatrix<double> M1,MMatrix<double> M2)
{
    int i;
    double res=0;
    for (i=0;i<M1.getHeight();i++)
    {
        res+=M1[i][0]*M2[i][0];
    }
    return res;
}
*/


/*

double spectral_radius(MMatrix<double> M)
{
   //return M.norm1();
    MMatrix<double> U(M.getHeight(),1);
    MMatrix<double> Ut(M.getHeight(),1);
    int i;
    double sum=0;
    U[0][0]=1.;
    U[1][0]=0;
    U[2][0]=0;
    for(i=0;i<40;i++)
    {
        Ut=multiply(M,U);
        U=(1./(Ut.norm2()))*Ut;
    }
    Ut=multiply(M,U);
   //    show(M);
   //    printf("\n %f",(Ut[0][0]/U[0][0]+Ut[1][0]/U[1][0]+Ut[2][0]/U[2][0])/3.);
    for(i=0;i<M.getHeight();i++)
    {
        sum=sum+Ut[i][0]/U[i][0];
    }
    return(abs(sum/M.getHeight()));

}
*/


MMatrix<double> real(MMatrix<Complex> A)
{
    MMatrix<double> Temp(A.getHeight(),A.getWidth());
    {

        const Complex* pData = A[0];
        double* pTemp = Temp[0]     ;
        for(int i=0,size=A.getHeight()*A.getWidth(); i<size ; ++i)
        {
            *pTemp = real(*pData++);
            *pTemp++;
        }
    }
    return Temp;

}

MMatrix<Complex> conj(MMatrix<Complex> A)
{
    MMatrix<Complex> Temp(A.getHeight(),A.getWidth());
    {

        const Complex* pData = A[0];
        Complex* pTemp = Temp[0]     ;
        for(int i=0,size=A.getHeight()*A.getWidth(); i<size ; ++i)
        {
            *pTemp = conj(*pData++);
            *pTemp++;
        }
    }
    return Temp;

}

//not tested
MMatrix<Complex> MMatrixDoubleToComplex(MMatrix<double> A)
{
    MMatrix<Complex> Temp(A.getHeight(),A.getWidth());
    {

        const double* pData = A[0];
        Complex* pTemp = Temp[0]     ;
        for(int i=0,size=A.getHeight()*A.getWidth(); i<size ; ++i)
        {
            *pTemp = ((Complex) (*pData++));
            *pTemp++;
        }
    }
    return Temp;
}
