// Written by J. Keller, julien.keller@univ-amu.fr (2014) //

#include "toricoptimaltransport2.h"

using namespace std;
int main(int argc, char *argv[])
{


char *display_type;
char *bitmap_size;
display_type = "X";/* format of plotter */
bitmap_size="1000x1000"; /* size in pixels of plotter */
int handle;
handle=init_plotsession(display_type,bitmap_size);

////////////////////////////////////////////////
/// important variables for the computations ///
////////////////////////////////////////////////
int k=16;//size of square (> length of edges see below when defining polytope)
int Trunc=40;//truncation to ignore tail of sums >10  - should be larger if one gets NAN values for PINTEGRAL  or star, and should be of size of k
int intnumber=100;//number of integration points in each variable
int iterationnumber=8;  //number of iterations of the algorithm >1
/// end of important variables for the computations ///



///////////////////////////////////////////////////////////////////////////////////////
/// DEFINING POLYGONS - they may represent some well known geometric toric manifolds
///////////////////////////////////////////////////////////////////////////////////////


///CP2
/*			
  int NV=3;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=-1;
del[2]=0;

ep[0]=0;
ep[1]=1;
ep[2]=-1;

mult[0]=20;
mult[1]=20;
mult[2]=20;
Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=0;
Qcood[NV]=0;

*/	
			
			




///CP1x CP1
			
int NV=4;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=0;
del[2]=-1;
del[3]=0;
ep[0]=0;
ep[1]=1;
ep[2]=0;
ep[3]=-1;
mult[0]=16;
mult[1]=16;
mult[2]=16;
mult[3]=16;
Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=0;
Qcood[NV]=0;

				


///CP^2  blown up in 1 point 
/* int NV=4;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=0;
del[2]=-1;
del[3]=0;
ep[0]=0;
ep[1]=1;
ep[2]=1;
ep[3]=-1;
mult[0]=8;
mult[1]=8;
mult[2]=8;
mult[3]=16;
Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=0;
Qcood[NV]=0;
*/
/*
int NV=4;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=1;
del[2]=-1;
del[3]=0;
ep[0]=-1;
ep[1]=0;
ep[2]=1;
ep[3]=-1;
mult[0]=8;
mult[1]=8;
mult[2]=16;
mult[3]=8;
Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=8;
Qcood[NV]=8;
*/

///Hirzebruch. 
/*
 int NV=4;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=0;
del[2]=-1;
del[3]=0;
ep[0]=0;
ep[1]=1;
ep[2]=-1;
ep[3]=-1;
mult[0]=8;
mult[1]=16;
mult[2]=8;
mult[3]=8;
Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=0;
Qcood[NV]=0;
*/

///Hirzebruch 2. 
/*
int NV=4;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=0;
del[2]=-1;
del[3]=0;

ep[0]=1;
ep[1]=1;
ep[2]=0;
ep[3]=-1;

mult[0]=4;
mult[1]=2;
mult[2]=4;
mult[3]=6;

Pcood[0]=5;
Pcood[NV]=0;
Qcood[0]=5;
Qcood[NV]=0;

*/


	
///CP^2  blown up in 2 points
/*   int NV=5;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex
del[0]=1;// we define the particular polygon we are using
del[1]=0;
del[2]=-1;
del[3]=-1;
del[4]=0;
ep[0]=0;
ep[1]=1;
ep[2]=1;
ep[3]=0;
ep[4]=-1;
mult[0]=16;
mult[1]=8;
mult[2]=8;
mult[3]=8;
mult[4]=16;

Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=0;
Qcood[NV]=0;
*/






///CP^2  blown up in 3 points - Hexagon
/*  int NV=6;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=1;
del[2]=0;

del[3]=-1;
del[4]=-1;
del[5]=0;

ep[0]=0;
ep[1]=1;
ep[2]=1;

ep[3]=0;
ep[4]=-1;
ep[5]=-1;

mult[0]=8;
mult[1]=8;
mult[2]=8;
mult[3]=8;
mult[4]=8;
mult[5]=8;
Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=0;
Qcood[NV]=0;
	*/


/// CP^2  blown up at 1 point
/* int NV=4;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=1;
del[2]=-1;
del[3]=0;
ep[0]=-1;
ep[1]=0;
ep[2]=1;
ep[3]=-1;
mult[0]=5;
mult[1]=10;
mult[2]=15;
mult[3]=10;
Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=5;
Qcood[NV]=0;
*/

/// Rectangular thin
/* int NV=4;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=0;
del[2]=-1;
del[3]=0;
ep[0]=0;
ep[1]=1;
ep[2]=0;
ep[3]=-1;
mult[0]=15;
mult[1]=1;
mult[2]=15;
mult[3]=1;
Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=0;
Qcood[NV]=0;
*/

/// Moebius strip
/*int NV=4;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=-1;
del[2]=-1;
del[3]=0;
ep[0]=0;
ep[1]=1;
ep[2]=0;
ep[3]=-1;
mult[0]=10;
mult[1]=5;
mult[2]=5;
mult[3]=5;
Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=0;
Qcood[NV]=0;
*/



/// Ring cyclide   - needs to be changed
/*  int NV=4;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=1;
del[2]=-1;
del[3]=-1;
ep[0]=-1;
ep[1]=1;
ep[2]=1;
ep[3]=-1;
mult[0]=5;
mult[1]=5;
mult[2]=5;
mult[3]=5;
Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=5;
Qcood[NV]=0;
*/

/// 1-horn cycle  - needs to be changed
/*int NV=3;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1;// we define the particular polygon we are using
del[1]=-1;
del[2]=-1;
ep[0]=0;
ep[1]=1;
ep[2]=-1;
mult[0]=20;
mult[1]=10;
mult[2]=10;
Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=0;
Qcood[NV]=0;
*/

/// Hexagon - needs to be changed
/*
int NV=6;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=1; // we define the particular polygon we are using
del[1]=1;
del[2]=1;
del[3]=-1;
del[4]=-1;
del[5]=-1;

ep[0]=-2;
ep[1]=0;
ep[2]=2;
ep[3]=2;
ep[4]=0;
ep[5]=-2;


mult[0]=5;
mult[1]=10;
mult[2]=5;
mult[3]=5;
mult[4]=10;
mult[5]=5;

Pcood[0]=0;
Pcood[NV]=0;
Qcood[0]=10;
Qcood[NV]=0;
*/





/// Weighted projective space blown up at 1 point 
/* int NV=5;//Number of vertices
int ep[NV]; //x2 component of primitive difference vector
int del[NV];//x1 component of primitive difference vector
int mult[NV];//"length" of edge--number of integer points minus 1
int Pcood[NV+1];//x1 coordinate of vertex
int Qcood[NV+1];//x2 coordinate of vertex

del[0]=0;// we define the particular polygon we are using
del[1]=1;
del[2]=1;
del[3]=0;
del[4]=-1;


ep[0]=-1;
ep[1]=-1;
ep[2]=1;
ep[3]=1;
ep[4]=0;


mult[0]=4;
mult[1]=4;
mult[2]=4;
mult[3]=4;
mult[4]=8;

Pcood[0]=4;
Pcood[NV]=0;
Qcood[0]=8;
Qcood[NV]=0;
*/

//////////////////////////////
/// END  choice of manifold
/////////////////////////////
	
/// other step to initialize :the function myfunction() - see below - for the volume form on the polygon ///



double stopconstant=.05;
pl_space (-3, -3, k+6, k+6); 
double kreal=double(k);  // just to manipulate k as a double
int nbsections=0;  // number of sections computed
feenableexcept(FE_INVALID | FE_OVERFLOW);  //debugger can find a NAN value 
//////////////////////////
///END initialization ///
//////////////////////////


VVector<double> powlist1,powlist2;   // list of power of monomials in variables w1 and w2
powlist1.resize(2*Trunc+9,1);
powlist2.resize(2*Trunc+9,1);


int ltrunc1;
int ltrunc2;
double Area=0.;
double trianglearea;
int boundarynumber=0;
double polymom1=0.;
double polymom2=0.;
double boundmom1=0.;
double boundmom2=0.;
double I11=0.;
double I12=0.;
double I22=0.;

for( int i=1;i<=NV;i++)
{
	Pcood[i]=Pcood[i-1]+del[i-1]*mult[i-1];
	Qcood[i]=Qcood[i-1]+ep[i-1]*mult[i-1];
	double Pir=double(Pcood[i]);
	double Pjr=double(Pcood[i-1]);
	double Qir=double(Qcood[i]);
	double Qjr=double(Qcood[i-1]);
	trianglearea=.5*mult[i-1]*(Pjr*double(ep[i-1])-Qjr*double(del[i-1]));
	Area=Area+trianglearea;
	polymom1=polymom1+trianglearea*((Pir/3.)+(Pjr/3.)-(kreal/2.));
	polymom2=polymom2+trianglearea*((Qir/3.)+(Qjr/3.)-(kreal/2.));
	I11=I11+trianglearea*(Pir*Pir+Pir*Pjr+Pjr*Pjr)/6.;
	I22=I22+trianglearea*(Qir*Qir+Qir*Qjr+Qjr*Qjr)/6.;
	I11=I11+trianglearea*(((kreal/2.)-2.*(Pir+Pjr)/3.)*(kreal/2.));
	I22=I22+trianglearea*(((kreal/2.)-2.*(Qir+Qjr)/3.)*(kreal/2.));
	I12=I12+trianglearea*(Pir*Qir+Pjr*Qjr+(Pir*Qjr+Pjr*Qir)/2.)/6.;
	I12=I12+trianglearea*(((kreal/2.)-(Pir+Pjr+Qir+Qjr)/3.)*(kreal/2.));
	boundarynumber=boundarynumber+mult[i-1];
	boundmom1=boundmom1+double(mult[i-1])*(Pir+Pjr-kreal)/2.;
	boundmom2=boundmom2+double(mult[i-1])*(Qir+Qjr-kreal)/2.;

}	
cout <<" AREA = "<< Area; 
	
double boundcm1=boundmom1/double(boundarynumber);
double boundcm2=boundmom2/double(boundarynumber);
double momdefect1=boundcm1-polymom1/Area;
double momdefect2=boundcm2-polymom2/Area;
I11=I11-polymom1*polymom1/Area;
I22=I22-polymom2*polymom2/Area;
I12=I12-polymom1*polymom2/Area;
	
double mu1;
double mu2;
mu1=I22*momdefect1-I12*momdefect2;
mu2=-I12*momdefect1+I11*momdefect2;
double detI=I11*I22-I12*I12;
mu1=mu1*double(boundarynumber)/detI;
mu2=mu2*double(boundarynumber)/detI;
//double invasc= Area/double(boundarynumber);
double tau1=polymom1/Area+kreal/2.;
double tau2=polymom2/Area+kreal/2.;


bool chi[k+1][k+1];//this is an indicator function for the integral points in the polygon
for (int p=0;p<=k;p++)
{
	for (int q=0;q<=k;q++)
	{
	chi[p][q]=1;
	for(int bet=0;bet<=NV-1;bet++)
	{
		int lambda= del[bet]*(q-Qcood[bet])-ep[bet]*(p-Pcood[bet]);
		if(lambda<0)
		{
		chi[p][q]=0;
		}
	}
	}
}
	
int polynumber=0;
double Zmom1=0.;
double Zmom2=0.;
double ZI11=0.;
double ZI12=0.;
double ZI22=0.;
for(int i=0;i<=k;i++)
{
	for(int j=0;j<=k;j++)
	{
	if (chi[i][j]==1)
	{
		polynumber=polynumber+1;
		Zmom1=Zmom1+(double(i)-kreal/2.);
		Zmom2=Zmom2+(double(j)-kreal/2.);
		ZI11=ZI11+(double(i)-kreal/2.)*(double(i)-kreal/2.);
		ZI12=ZI12+(double(i)-kreal/2.)*(double(j)-kreal/2.);
		ZI22=ZI22+(double(j)-kreal/2.)*(double(j)-kreal/2.);
	}
	}
}
ZI11=ZI11-Zmom1*Zmom1/double(polynumber);
ZI12=ZI12-Zmom1*Zmom2/double(polynumber);
ZI22=ZI22-Zmom2*Zmom2/double(polynumber);
double detZI=ZI11*ZI22-ZI12*ZI12;
	
for(int i=0;i<=NV-1;i++)
{
	pl_pencolorname("green");
	pl_line (Pcood[i],Qcood[i],Pcood[i+1],Qcood[i+1]);//draw the polygon
}
MMatrix<double> simpleterms(2*Trunc+1,5);
for(int i=-Trunc;i<=Trunc;i++)
{
	for(int a=0;a<=4;a++)
	{
		simpleterms[i+Trunc][a]=smallprod(i,a);
	}
}


MMatrix<double> B(k+1,k+1);//coefficient array of the Bergman metric we are looking for
MMatrix<double> powers(k+1,k+1);//array to hold monomials at each point


///initialization of the Bergman metric B at step 0///
double lamb;
srand (time(NULL));
for(int i=0;i<=k;i++)
{
	for(int j=0;j<=k;j++)
	{
	if (chi[i][j]==1)
		for(int bet=0;bet<=NV-1;bet ++)
	{
		
		lamb=double(del[bet])*(double(j)-double(Qcood[bet]))-double(ep[bet])*(double(i)-double(Pcood[bet]));
		lamb=lamb/kreal;
		B[i][j]=B[i][j]-XlogX(lamb)+ (rand()% 50)/200.;//I add some randomness to start with,maybe a better formula than  (rand()% 50)/200. ?
	}
	B[i][j]=exp(.25*kreal*B[i][j]);
	}
}

/// show(B);getchar();

////////////////////////////////
////variables for computations
////////////////////////////////
double zmax=0.;
double sum=0.;

MMatrix<double> PINTEGRAL(k+1,k+1);//the array of integrals for the balancing algorithm


	
double intstep=1.0/(double(intnumber)); //integral step	
double lam[NV-1];//these are the values of the affine linear functions
int alp=0;//label of chart we are in
int alpnew;
int gam=NV-1;
//   double mindist;//criterion for choice of chart
double x1;//coordinates of point in polygon
double x2;
double z1;//coordinates in our chart
double z2;
double w1; //coordinates squared
double w2;
MMatrix<double> DD(5,5);	// will contain the derivatives of the potential; DD[0][0] is the sum of normed sections pointwise
double ratal;//ratios of z-variables and lambda variables
double ratgam;
double acomp;//components of  Hessian matrix
double bcomp;
double dcomp;
double Aab;
double Bab;
double Jac;//gives the Jacobian for change of variables in integrals
bool indic;
int count;
double badness;
int chartmove;
double sumterm;
double term;
double weyl=0.;  // weyl curvature
double Riemnorm=0.; // norm of Riemannian tensor
double scal=0;  // scalar curvature
Data_in Data;
int i,j,r,s,p,q,a,b;
double weight;  // weight for integration 
double shift1,shift2,xpt1,xpt2;

double prod1;
//Data.invasc=invasc;
int basepp,baseqq;
int basep,baseq,basei,basej;
double muc,sig1,sig2,Zlam1,Zlam2,absSab;

double sumlcoff,momcoff1,momcoff2,star;
double logterm,newB;
double sumcoff,bmax,bmin;  // sum of coeff of the Bergman matrix B, min of coeff, max of coeff
VVector<double> Maverage; //contains some data results : Maverage[0]= number of points on the polygon 
Maverage.resize(6,1);
double Xw11,Xw22,Xw12; 
double nbpoints; // number of points computed




////the big loop : we apply the method itnumber times
for(int itnumber=0;itnumber<=iterationnumber;itnumber++)
{  

	//start of iteration loop
	if((itnumber) % (iterationnumber/5+1)==0)
	{
		pl_erase();
		for(int i=0;i<=NV-1;i++)
		{
			pl_pencolorname("pink");
			pl_line (Pcood[i],Qcood[i],Pcood[i+1],Qcood[i+1]);//draw the polygon
		}
	}
        //getchar();  for display of the polygon

	basep=0;
	baseq=0;
	basei=0;
	basej=0;
	sum=0.;
	PINTEGRAL.fillWith(0);
	zmax=0.;

	int sign=-1;
	alp=0;
	for (int f=0;f<=intnumber;f++)
	{
		sign=-sign;	//START F-LOOP

		for (int g=0;g<=intnumber;g++)
		{		//START G-LOOP

			x1=kreal*double(f)*intstep;
			if(sign==1)
			{
				x2=kreal*double(g)*intstep;
			}
			if(sign==-1)
			{
				x2=kreal*(1.-double(g)*intstep);
			}
			indic=1;//this is 0 if outside polygon
			for (int bet=0;bet<=NV-1;bet++)
			{
				lam[bet]= (del[bet])*(x2-(Qcood[bet]))-(ep[bet])*(x1-(Pcood[bet]));
				lam[bet]=lam[bet]/kreal;
				if(lam[bet]<-SMALL_BOUND1)
				{
					indic=0;
				}
				if(lam[bet]<0.)
				{
					lam[bet]==0.;
				}
			}	
		
			if (indic==1)//START OF MAIN LOOP:we only calculate if inside polygon
			{
				alpnew=alp;
				badness=2.;
				count=0;
				do
				{	//start of loop to find a good chart
					alp=alpnew;
					ratal=1.;//setting all these to 0 or 1 before the sum or product below
					ratgam=1.;
					acomp=0.;
					bcomp=0.;
					dcomp=0.;
					gam=cyclic(alp,NV,-1);
		
					for (int bet=0;bet<=NV-1;bet++)
					{
						if(bet!=alp&&bet!=gam)
						{
							ratal=ratal*pow(lam[bet],del[gam]*ep[bet]-del[bet]*ep[gam]);
							ratgam=ratgam*pow(lam[bet],del[bet]*ep[alp]-del[alp]*ep[bet]);
							Aab=double(del[gam]*ep[bet]-del[bet]*ep[gam]);
							Bab=double(del[bet]*ep[alp]-del[alp]*ep[bet]);
							acomp=acomp+ (1/lam[bet])*Aab*Aab;
							bcomp=bcomp+(1/lam[bet])*Aab*Bab;
							dcomp=dcomp+(1/lam[bet])*Bab*Bab;
		
						}
					}
	
					z2=lam[alp]*ratal;
					z1=lam[gam]*ratgam;
		
					badness=z2;
					chartmove=-1;
					if(z1>=z2)
					{
						chartmove=1;
						badness=z1;
					}	
					if(badness>1.01)
					{
						alpnew=cyclic(alp,NV,chartmove);
						count=count+1;
					}
	
					if(count>2)
					{
						cout<<"Chart moves "<<count << "   ";
					}
		
				}
				while(badness>1.01&&count<NV);//end of "while badness" loop. Now we have a choice of chart, label "alp"

				if(z1>zmax)
				{
					zmax=z1;
				}
				if(z2>zmax)
				{
					zmax=z2;
				}
	
				Jac=1+lam[alp]*acomp+lam[gam]*dcomp+lam[alp]*lam[gam]*(acomp*dcomp-bcomp*bcomp);// CHANGED THIS
				Jac=Jac*lam[alp]*lam[gam]*ratal*ratal*ratgam*ratgam; // computation of Jacobian at the point
	
				w1=z1*z1;//now we start doing all calculations at this point
				w2=z2*z2;
		
				basei=(baseq-Qcood[alp])*del[gam]-(basep-Pcood[alp])*ep[gam];
				basej=(baseq-Qcood[alp])*del[alp]-(basep-Pcood[alp])*ep[alp];
				///////////////////////////////
				///computation of the monomials
				//////////////////////////////
				int ppp;
				int qqq;
				basei=0;//these are set to zero. If we change that we need to modify calc for norms[][] below
				basej=0;
	
				if (w1<.1)
				{
					basei=0;
				}
				if(w2<.1)
				{
					basej=0;
				}
	
				ltrunc1=basei;
				if(ltrunc1>Trunc)
				{
					ltrunc1=Trunc;
				}
				ltrunc2=basej;
				if(ltrunc2>Trunc)
				{
					ltrunc2=Trunc;
				}
				DD.fillWith(0);
				p=Pcood[alp]+basei*del[alp]-basej*del[gam];
				q=Qcood[alp]+basei*ep[alp]-basej*ep[gam];
				powlist1.fillWith(0);
				powlist2.fillWith(0);
				powlist1[Trunc+4]=1.;
				powlist2[Trunc+4]=1.;
				for (i=1;i<=Trunc+4;i++)
				{
					powlist1[Trunc+4+i]=powlist1[Trunc+3+i]*w1;
					powlist2[Trunc+4+i]=powlist2[Trunc+3+i]*w2;
					if(i<=ltrunc1+4)
					{
						powlist1[Trunc+4-i]=1./powlist1[Trunc+4+i];
					}
					if(i<=ltrunc2+4)
					{
						powlist2[Trunc+4-i]=1./powlist2[Trunc+4+i];
					}
				}
				/////////////////////////////////////////////////
				/// Computations of sections and its derivatives
				/////////////////////////////////////////////////
				nbsections=0;
				for(i=-ltrunc1;i<=Trunc;i++)
				{
					for(j=-ltrunc2;j<=Trunc;j++)
					{
		
		
						r=p+i*del[alp]-j*del[gam];//int r=1+i*del[alp]-j*del[gam];
						s=q+i*ep[alp]-j*ep[gam];
		
						if(insquare(r,s,k)==1)
						{
							if(chi[r][s]==1)
							{
								powers[r][s]=powlist1[Trunc+4+i]*powlist2[Trunc+4+j];
								nbsections++;
								for(a=0;a<=2;a++)   // a<=4 if we need more curvature terms
								{
									for(b=0;b<=2-a;b++)  // b<=4-a  if we need more curvature terms
									{
										term=simpleterms[i+Trunc][a]*simpleterms[j+Trunc][b];
										///( 0.01< term * term )
										if ( 0.001< term * term )
										{
										        sumterm=term*B[r][s]*powlist1[Trunc+4+i-a]*powlist2[Trunc+4+j-b];
											DD[a][b]+=sumterm;
			
			
										}	//end if
									}	//end b
								}	//end a
							}//end if
						}//end if
					}//endj
				}//endi

		
				/////////////////////////////////////////////////
				//// computation of curvatures
				///////////////////////////////////////////////
				
				compute_curvatures_local(DD,scal,Riemnorm,weyl,z1,z2,Data);
				
				
				Maverage[0]++; // counting number of points
				///if (itnumber==0)
				///{
				///	Maverage[1]=???; // to be chosen by hand if we want to show the first Bergman matrix at step 0
				///}
				
				if((itnumber+1) % (iterationnumber/5+1)==0 )
				{
					Maverage[1]+=Data.det/nbpoints;  // computation of normalized volume of the Bergman metric
					Maverage[2]+=myfunction(w1,w2)/nbpoints;    // computation of the normalized volume wrt to the volume form we have chosen a priori 
					//cout << "\n  "<< Data.det/nbpoints;getchar();
				}
			
				Xw11= Data.p20+Data.p11+ Data.p20+w1*Data.p21;
				Xw22= Data.p11+Data.p02+ Data.p02+w2*Data.p12;
				Xw12= z2*Data.p11+z1*Data.p11+z1*z2*Data.p21+z1*z2*Data.p12;
				
				/////////////////////////////////////////////////////
				
				shift1=w1*Data.p10+double(basei);
				shift2=w2*Data.p01+double(basej);
				xpt1=(Pcood[alp])+shift1*(del[alp])-shift2*(del[gam]);
				xpt2=(Qcood[alp])+shift1*(ep[alp])-shift2*(ep[gam]);
				//these are the points in the hexagon which we map to under the Legendre transform.

				basei=int(shift1);
				basej=int(shift2);
				if (shift1<.5)
				{
					basei=0;
				}
				if(shift2<.5)
				{
					basej=0;
				}
				basep=Pcood[alp];
				baseq=Qcood[alp];
				basepp=Pcood[alp]+basei*del[alp]-basej*del[gam];
				baseqq=Qcood[alp]+basei*ep[alp]-basej*ep[gam];
				if(insquare(basepp,baseqq,k)==1&&chi[basepp][baseqq]==1)
				{
					basep=basepp;
					baseq=baseqq;
				}	
				weight=intstep*intstep;
				sum=sum+Jac*Data.det*weight;
			

				if((itnumber % (iterationnumber/5+1)==0 and itnumber>0 )) //one can do the test for itnumber==0
				{
					///if( abs(Data.det/Maverage[1]-1.0)>0.2)
					///{  
					///if(myfunction(w1,w2)/Maverage[2]>1.4 or myfunction(w1,w2)/Maverage[2]<0.6)
					///  cout << "\n Data.det = " << Data.det/Maverage[1]  << " myfunction(w1,w2)= " << myfunction(w1,w2)/Maverage[2];  // test to check points far from average
					///}
					Maverage[3]+=abs(Data.det/(Maverage[1]) / (myfunction(w1,w2)/Maverage[2])   -1.0)*weight*Jac; // computes the L1 error of the MA 
					Maverage[4]+=pow(abs(Data.det/(Maverage[1]) / (myfunction(w1,w2)/Maverage[2])   -1.0),2.0)*weight*Jac; // computes the L2 error of the MA 
					Maverage[5]=max(abs(Data.det/(Maverage[1]) / (myfunction(w1,w2)/Maverage[2])   -1.0),Maverage[5]); // computes the C^0 norm of the MA error
					sixcolourplot(  (Data.det/(Maverage[1]) / (myfunction(w1,w2)/Maverage[2])   -1.0),xpt1,xpt2,-0.3,  -.2 ,0, .2, 0.3,k);		
				}
				///prod1=Jac*Data.det*weight/DD[0][0]; // genuine balanced method 
				///prod1=Jac*weight/DD[0][0];    // volume form == 1
				prod1=Jac*weight*myfunction(w1,w2)/DD[0][0];   //volume form is fixed 
				//cout << " prod 1 "<< prod1 << endl;
				PINTEGRAL+=(prod1)*powers;
                               // show(powers); getchar();
				powers.fillWith(0);
			}	      //END MAIN LOOP  - end indic
		}//END G-LOOP
	}//END F-LOOP
	sumlcoff=0.;
	momcoff1=0.;
	momcoff2=0.;
	//show(PINTEGRAL); getchar();
	for(a=0;a<=k;a++)
	{
		for(b=0;b<=k;b++)
		{
			if(chi[a][b]==1)
			{
		
				star=-log(PINTEGRAL[a][b]);
				//Lcoff[a][b]=star;
				sumlcoff=sumlcoff+star;
				momcoff1=momcoff1+(double(a)-kreal/2.)*star;
				momcoff2=momcoff2+(double(b)-kreal/2.)*star;
			}
		}
	}
	muc=3.-(sumlcoff/(polynumber));
	sig1=kreal/2.+Zmom1/(polynumber);
	sig2=kreal/2.+Zmom2/(polynumber);
	momcoff1=momcoff1-sumlcoff*Zmom1/(polynumber);
	momcoff2=momcoff2-sumlcoff*Zmom2/(polynumber);
	Zlam1= (ZI12*momcoff2-ZI22*momcoff1)/detZI;
	Zlam2= (ZI12*momcoff1-ZI11*momcoff2)/detZI;
	//newdel=1;
	for(a=0;a<=k;a++)
	{
		for (b=0;b<=k;b++)
		{
			if(chi[a][b]==1)
			{
				logterm=muc+Zlam1*(a-sig1)+Zlam2*(b-sig2);
				///   newB=exp(logterm)*(1+delt[a][b])/PINTEGRAL[a][b]; Don
				newB=exp(logterm)/PINTEGRAL[a][b];
				
				B[a][b]=newB;
				PINTEGRAL[a][b]=0.;
			}
		}
	}
	bmax=B.max();
	bmin=B.min();
	sumcoff=B.sum();

	cout<<"\n*******"<<endl;
	std::cout<<"Iteration number: "<<(itnumber)<<endl;
	std::cout<< "Number of points computed: " << Maverage[0] <<endl;
	std::cout<< "Number of used sections : " << nbsections<<endl<<endl;
	std::cout<<"Max coefficient of the Bergman metric: "<<bmax<<endl;
	std::cout<<"Min coefficient of the Bergman metric: "<<bmin<<endl;
	std::cout<<"Sum coeff of the Bergman metric: " << B.sum()<<endl;
	if (itnumber==0)
	{
		nbpoints=Maverage[0];
	}
	if((itnumber+1) % (iterationnumber/5+1)==0 )
	{
		cout << "\n Volume average of Bergman metric: "<<Maverage[1];
	}
	if((itnumber) % (iterationnumber/5+1)==0 and itnumber>0)
	{
		cout << "\n L1 norm of error in MA: "<<Maverage[3];
		cout << "\n L2 norm of error in MA: "<<sqrt(Maverage[4]);
		cout << "\n C^0 norm of error in MA: "<<Maverage[5];
		Maverage[1]=0;
		Maverage[2]=0;
                Maverage[3]=0;
                Maverage[4]=0;
		Maverage[5]=0;
	}

	cout << "\n";
	///Maverage.fillWith(0);
	Maverage[0]=0;
	
}//end of iteration loop iteration of the whole method 

cout << "\n Press Enter..";
getchar();

return EXIT_SUCCESS;//always have this to show we have exited properly


} //end of main


int insquare(int p, int q, int k)
{

	if(0>p || p>k || q<0 || q>k)
	{
		return(0);
	}
	else return(1);
	}
	double XlogX(double x)
	{
	
	if(x>SMALL_BOUND_LOG)
	{
		return(x*log(x));
	}
	else return 0;
}

double smallprod(int i, int a)
{
	switch(a)
	{
		case 0:
		return(1.);
		case 1:
		return(double (i));
		case 2:
		return(double  (i*(i-1.)));
		case 3:
		return(double (i*(i-1.)*(i-2.)));
		case 4:
		return(double (i*(i-1.)*(i-2.)*(i-3.)));
		case 5:
		return(double (i*(i-1.)*(i-2.)*(i-3.)*(i-4.)));
	}
}

int cyclic(int r,int N,int i)
{
	
	if(i==-1)
	{
		return( (r==0)?N-1:r-1);
	}
	if(i==1)
	{
		return( (r==N-1)? 0:r+1);
	}
}





void sixcolourplot(double var, double cd1,double cd2,double a1,double a2,double a3,double a4,double a5,int k)
{
	if(var>a5)	
	{
		pl_pencolorname ("red");
		pl_fmarker(cd1,cd2,3,.1);
	}
	
	if  (var<a5&&var>=a4)
	{
		pl_pencolorname ("orange");
		pl_fmarker(cd1,cd2,3,.1);
	}
	if(var<=a4/2. && var >= a2/2.)
	{
		pl_pencolorname ("green");
		pl_fmarker(cd1,cd2,3,.1);
	}
	if((a2<=var && var<a2/2.)  || (var>a4/2. && var<a4))
	{
		pl_pencolorname ("yellow");
		pl_fmarker(cd1,cd2,3,.1);
	}
	if(var<a2&&var>=a1)
	{
		pl_pencolorname ("blue");
		pl_fmarker(cd1,cd2,3,.1);
	}
	if(var<a1)
	{
		pl_pencolorname("black");
		pl_fmarker(cd1,cd2,3,.1);
	}
	pl_fontname("Courier");
	pl_fontsize(-1);
	pl_pencolorname("Black");
	pl_fmove(-1.5,-.9);
	pl_label("M-A error:");  // Showing pointwise error = Monge-Ampère of the metric computed - a priori fixed volume form on the polytope 
	pl_fmove(-1.5,-1.7);
	pl_label("red:err>0.3");
	pl_fmove(4.5,-1.7);
	pl_label("orange:0.2<err<0.3");
	pl_fmove(12,-1.7);
	pl_label("yellow:0.1<|err|<0.2");
	pl_fmove(-1.5,-2.5); 
	pl_label("green:|err|<0.1");
	pl_fmove(4.5,-2.5);
	pl_label("blue:-0.3<err<-0.2");
	pl_fmove(12,-2.5);
	pl_label("black:err<-0.3");
	
}

void compute_curvatures_local(MMatrix<double> &DD,double & scal,double & Riemnorm, double & weyl,
			double z1,double z2, Data_in & Data)
{
	
	
	//int i,j,k,l,a,b,c,d;
	//double w1=z1*z1;
	//double w2=z2*z2;
	
	/*
	double F,p10,p01,p20,p11,p02,p30,p21,p12,p03;
	double p40,p04,p31,p13,p22;
	double hxx,hyy,hxy,det,ixx,ixy,iyy,cPx,cRy,cQx,cQy,cRx,cPy;
	double phiPP,phiRR,phiPQ,phiQR,phiPR,phiQQ;
	double BPP,BRR,BPQ,BQR,BPR,BQQ;
	
	double ricxx,ricyy,ricxy,detricci,tfricsize,gauss,beta,gamma;
	double W[5];
	double inv[2][2];
	double S[2][2][2][2];
	double Riem[2][2][2][2];
	*/
	//  weyl=0.;
	//  Riemnorm=0.;
	//  scal=0.;
	
	Data.F=DD[0][0];
	Data.p10=DD[1][0]/Data.F;//pab denotes derivatives of phi=logF,a derivs in w1 and b in w2; not all derivatives are needed
	Data.p01=DD[0][1]/Data.F;
	Data.p20=DD[2][0]/Data.F-Data.p10*Data.p10;
	Data.p11=DD[1][1]/Data.F-Data.p10*Data.p01;
	Data.p02=DD[0][2]/Data.F-Data.p01*Data.p01;




        Data.p21=2.*Data.p10*Data.p11+Data.p01*Data.p20+Data.p10*Data.p10*Data.p01;
	Data.p12=2.*Data.p01*Data.p11+Data.p10*Data.p02+Data.p01*Data.p01*Data.p10;
	Data.p21=(DD[2][1]/Data.F)-Data.p21;
	Data.p12=(DD[1][2]/Data.F)-Data.p12;

/*
	Data.p30=3.*Data.p10*Data.p20+Data.p10*Data.p10*Data.p10;	
	Data.p03=3.*Data.p01*Data.p02+Data.p01*Data.p01*Data.p01;
	Data.p30=(DD[3][0]/Data.F)-Data.p30;
	Data.p03=(DD[0][3]/Data.F)-Data.p03;
	Data.p40=4.*Data.p10*Data.p30+3.*Data.p20*Data.p20+6.*Data.p20*Data.p10*Data.p10+Data.p10*Data.p10*Data.p10*Data.p10;
	Data.p04=4.*Data.p01*Data.p03+3.*Data.p02*Data.p02+6.*Data.p02*Data.p01*Data.p01+Data.p01*Data.p01*Data.p01*Data.p01;
	Data.p31=3.*Data.p10*Data.p21+Data.p01*Data.p30+3.*Data.p11*Data.p20+3.*Data.p20*Data.p10*Data.p01+3.*Data.p11*Data.p10*Data.p10+Data.p01*Data.p10*Data.p10*Data.p10;
	Data.p13=3.*Data.p01*Data.p12+Data.p10*Data.p03+3.*Data.p11*Data.p02+3.*Data.p02*Data.p01*Data.p10+3.*Data.p11*Data.p01*Data.p01+Data.p10*Data.p01*Data.p01*Data.p01;
	

        Data.p22=2.*Data.p10*Data.p12+2.*Data.p01*Data.p21+Data.p20*Data.p02+2.*Data.p11*Data.p11+Data.p20*Data.p01*Data.p01+Data.p02*Data.p10*Data.p10;
	Data.p22=Data.p22+4.*Data.p11*Data.p10*Data.p01+Data.p10*Data.p10*Data.p01*Data.p01;
	Data.p40=(DD[4][0]/Data.F)-Data.p40;
	Data.p31=(DD[3][1]/Data.F)-Data.p31;
	Data.p22=(DD[2][2]/Data.F)-Data.p22;
	Data.p13=(DD[1][3]/Data.F)-Data.p13;
	Data.p04=(DD[0][4]/Data.F)-Data.p04;
*/	
	
	
	Data.hxx=Data.p10+z1*z1*Data.p20;//h is the metric tensor; x and y are other names for  z1,z2
	Data.hyy=Data.p01+z2*z2*Data.p02;
	Data.hxy= z1*z2*Data.p11;
	Data.det= Data.hxx*Data.hyy-Data.hxy*Data.hxy;  // this is the volume of the Bergman metric
	/*
	Data.ixx=Data.hyy/Data.det; //i is the inverse (upper indices)
	Data.ixy=-Data.hxy/Data.det;
	Data.iyy=Data.hxx/Data.det;
	
	Data.cPx= z1*(2.*Data.p20+ w1*Data.p30);//these are the third deriv. terms
	Data.cRy= z2*(2.*Data.p02+ w2*Data.p03);
	Data.cQx= z2*(Data.p11+w1*Data.p21);
	Data.cQy= z1*(Data.p11+w2*Data.p12);
	Data.cRx= w2*z1*Data.p12;
	Data.cPy= w1*z2*Data.p21;
	
	Data.phiPP=2.*Data.p20+4.*w1*Data.p30+w1*w1*Data.p40;//these are the fourth deriv. terms
	Data.phiRR=2.*Data.p02+4.*w2*Data.p03+w2*w2*Data.p04;
	Data.phiPQ=z2*z1*(2.*Data.p21+ w1*Data.p31);
	Data.phiQR=z1*z2*(2.*Data.p12+w2*Data.p13);
	Data.phiPR=w1*w2*Data.p22;
	Data.phiQQ= Data.p11+w1*Data.p21+w2*Data.p12+w1*w2*Data.p22;
	
	Data.BPP=Data.cPx*Data.cPx*Data.ixx+(Data.cPy*Data.cPx+Data.cPx*Data.cPy)*Data.ixy+Data.cPy*Data.cPy*Data.iyy;//this computes quadratic in third derivs.
	Data.BRR=Data.cRx*Data.cRx*Data.ixx+(Data.cRy*Data.cRx+Data.cRx*Data.cRy)*Data.ixy+Data.cRy*Data.cRy*Data.iyy;
	Data.BPQ=Data.cPx*Data.cQx*Data.ixx+(Data.cPx*Data.cQy+Data.cQx*Data.cPy)*Data.ixy+Data.cPy*Data.cQy*Data.iyy;
	Data.BQR=Data.cQx*Data.cRx*Data.ixx+(Data.cQx*Data.cRy+Data.cRx*Data.cQy)*Data.ixy+Data.cQy*Data.cRy*Data.iyy;
	Data.BPR=Data.cPx*Data.cRx*Data.ixx+(Data.cPx*Data.cRy+Data.cRx*Data.cPy)*Data.ixy+Data.cPy*Data.cRy*Data.iyy;
	Data.BQQ=Data.cQx*Data.cQx*Data.ixx+(Data.cQx*Data.cQy+Data.cQy*Data.cQx)*Data.ixy+Data.cQy*Data.cQy*Data.iyy;
	
	Data.BPP=-Data.invasc*(Data.phiPP-Data.BPP);
	Data.BRR=-Data.invasc*(Data.phiRR-Data.BRR);
	Data.BPQ=-Data.invasc*(Data.phiPQ-Data.BPQ);
	Data.BQR=-Data.invasc*(Data.phiQR-Data.BQR);
	Data.BPR=-Data.invasc*(Data.phiPR-Data.BPR);
	Data.BQQ=-Data.invasc*(Data.phiQQ-Data.BQQ);//now BPQ etc are components of curvature tensor, "factor"normalises scale
	
	Data.ricxx= (Data.BPP*Data.ixx+2.*Data.BPQ*Data.ixy+Data.BQQ*Data.iyy);//contract for Ricci
	Data.ricyy=(Data.BRR*Data.iyy+2.*Data.BQR*Data.ixy+Data.BQQ*Data.ixx);
	Data.ricxy=(Data.BPQ*Data.ixx+Data.BPR*Data.ixy+Data.BQQ*Data.ixy+Data.BQR*Data.iyy);
	
	scal=Data.ricxx*Data.ixx+2.*Data.ricxy*Data.ixy+Data.ricyy*Data.iyy;
	
	
	Data.detricci=Data.ricxx*Data.ricyy-Data.ricxy*Data.ricxy;
	Data.tfricsize= sqrt(scal*scal-4.*Data.detricci/Data.det);//absolute value of Ricci eigenvalue difference
	Data.gauss=(Data.BPR-Data.BQQ)/(4.*Data.det);// Gauss curvature in horizontal plane, up to a factor.
	Data.beta=Data.gauss-scal/8.;
	Data.gamma=2.*Data.det*Data.beta;
	
	Data.W[0]=Data.BPP-Data.ricxx*Data.hxx-Data.beta*Data.hxx*Data.hxx;
	Data.W[1]=Data.BPQ-.5*(Data.ricxx*Data.hxy+Data.ricxy*Data.hxx)-Data.beta*Data.hxx*Data.hxy;
	Data.W[2]=Data.BPR-.5*(Data.ricxx*Data.hyy+Data.ricyy*Data.hxx)-Data.beta*Data.hxx*Data.hyy-Data.gamma;
	Data.W[3]=Data.BQR-.5*(Data.ricyy*Data.hxy+Data.ricxy*Data.hyy)-Data.beta*Data.hyy*Data.hxy;
	Data.W[4]=Data.BRR-Data.ricyy*Data.hyy-Data.beta*Data.hyy*Data.hyy;
	
	
	Data.inv[0][0]=Data.ixx;
	Data.inv[0][1]=Data.ixy;
	Data.inv[1][0]=Data.ixy;
	Data.inv[1][1]=Data.iyy;
	
	
	for (int i=0;i<=1;i++)
	{
		for (int j=0;j<=1;j++)
		{
		for (int k=0;k<=1;k++)
		{
			for (int l=0;l<=1;l++)
			{	
			Data.S[i][j][k][l]=Data.W[i+j+k+l];
			if(i+j+k+l==0)
			{
				Data.Riem[i][j][k][l]=Data.BPP;
			}
			if(i+j+k+l==4)
			{
				Data.Riem[i][j][k][l]=Data.BRR;
			}
			if(i+j+k+l==1)
			{
				Data.Riem[i][j][k][l]=Data.BPQ;
			}
			if(i+j+k+l==3)
			{
				Data.Riem[i][j][k][l]=Data.BQR;
			}
			if(i+j+k+l==2)
			{
				Data.Riem[i][j][k][l]=Data.BPR;
				if(i+j==1)
				{
				Data.Riem[i][j][k][l]=Data.BQQ;
				}
			}
			}
		}
		}
	}
	
	
	for (int i=0;i<=1;i++)
	{
		for (int j=0;j<=1;j++)
		{
		for(int k=0;k<=1;k++)
		{
			for(int l=0;l<=1;l++)
			{
			for(int a=0;a<=1;a++)
			{
				for(int b=0;b<=1;b++)
				{	
				for(int c=0;c<=1;c++)
				{
					for(int d=0;d<=1;d++)
					{
					weyl=weyl+Data.S[i][j][k][l]*Data.S[a][b][c][d]*Data.inv[i][a]*Data.inv[j][b]*Data.inv[k][c]*Data.inv[l][d];
					Riemnorm=Riemnorm+Data.Riem[i][j][k][l]*Data.Riem[a][b][c][d]*Data.inv[i][a]*Data.inv[j][b]*Data.inv[k][c]*Data.inv[l][d];
					}
				}
				}
			}
			}
		}
		}
	}
	weyl=sqrt(weyl);//now we have finished all curvature calculations
	Riemnorm=sqrt(Riemnorm);// nrom of curvature tensor
	
	
	
	if (print_results==1){
		cout<<"\n curvatures (scalar,det of Ricci,Gauss) "<<scal<< " "<<Data.detricci<< " "<<Data.gauss <<" \n";
	}
	*/  
}  //end of compute curvature


double myfunction(double w1,double w2) //here we define an a priori volume form on the polygon - one can choose various volume forms
 // must return a value >=0
{
   return 50*(1.01+cos(w1+w2));
//       50*(1.01+cos(w1+w2));  // this function does not vary too much to its average
// max(5*((w1+w2)*(w1+w2)*cos(w1+w2) + w1*sin(w1)+w2*sin(w2) ),0.01); // this function varies a lot to its average
//       50*(1.01+cos(w1+w2) + );  
// 	max(50*(cos(w1+w2) + w1*sin(w1)+w2*sin(w2) ),0.01);  

}
