// Written by J. Keller, julien.keller@univ-amu.fr (2014) //
#ifndef TORIC_CSCK_H
#define TORIC_CSCK_H
//#include "m_matrix2.h"
//#include <MMatrix.h>>
#include <stdio.h>
#include <stdlib.h>
#include <iomanip>
 
#include <math.h>
#include <iostream>
#include <cstdlib>

#include <plot.h>		

#include "MMatrix.h" //library to handle matrices in memory quickly
#include "m_matrix2.h" //library for standard procedures on matrices
#include "plotter.h"
#include <fenv.h>

#define pow2(x) (x*x)
#define pow3(x) (x*x*x)
#define pow4(x) pow2(x*x)
#define pow5(x) (x*pow4(x))
#define pow6(x) pow2(pow3(x))
#define pow8(x) pow2(pow4(x))
#define pow_1(x) (1./x)
#define pow_2(x) (1./(x*x))
#define pow_3(x) (1./(x*x*x))
#define pow_4(x) (1./(pow2(x*x)))

#define SMALL_BOUND1 .000000001
#define SMALL_BOUND_LOG 0.000001
double cutoffFunct(double y);
double smallprod(int n,int r);
int insquare(int p, int g, int k);
int cyclic(int r, int N, int i);
void sixcolourplot(double variable,double cd1,double cd2,double a1,double a2,double a3,double a4,double a5,int k);
double XlogX(double x);
double myfunction(double w1,double w2);

//Generic variables
int print_results=0;

struct Data_in{
  //  double invasc;
    double F,p10,p01,p20,p11,p02,p30,p21,p12,p03;
   // double p40,p04,p31,p13,p22;
    double hxx,hyy,hxy,det,ixx,ixy,iyy,cPx,cRy,cQx,cQy,cRx,cPy;
 

 /*   double phiPP,phiRR,phiPQ,phiQR,phiPR,phiQQ;
    double BPP,BRR,BPQ,BQR,BPR,BQQ;
   
    double ricxx,ricyy,ricxy,detricci,tfricsize,gauss,beta,gamma;
    double W[5];
    double inv[2][2];
    
    double S[2][2][2][2];
    double Riem[2][2][2][2];*/
};
void compute_curvatures_local(MMatrix<double> &DD,double & scal,double & Riemnorm, double & weyl,
                              double z1,double z2, Data_in & Data);    

#endif

